/*******************************************************************************
 * Copyright (c) 2008 IGA Tosiki, NTT DATA BUSINESS BRAINS Corp.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    IGA Tosiki (NTT DATA BUSINESS BRAINS Corp.) - initial API and implementation
 *******************************************************************************/
/*
 * blanco Framework
 * Copyright (C) 2008 NTT DATA BUSINESS BRAINS CORPORATION
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
package blanco.ibatis.task;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.sql.Connection;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import blanco.commons.util.BlancoNameAdjuster;
import blanco.db.util.BlancoDbMappingUtilJava;
import blanco.dbmetadata.BlancoDbMetaDataSql;
import blanco.dbmetadata.BlancoDbMetaDataUtil;
import blanco.dbmetadata.valueobject.BlancoDbMetaDataColumnStructure;
import blanco.ibatis.message.BlancoIBatisMessage;
import blanco.ibatis.task.valueobject.BlancoIBatisSqlMap2RowProcessInput;
import blanco.valueobject.BlancoValueObjectXml2JavaClass;
import blanco.valueobject.valueobject.BlancoValueObjectClassStructure;
import blanco.valueobject.valueobject.BlancoValueObjectFieldStructure;

import com.ibatis.common.beans.ProbeException;
import com.ibatis.common.xml.NodeletException;
import com.ibatis.sqlmap.engine.builder.xml.SqlMapParser;
import com.ibatis.sqlmap.engine.builder.xml.XmlParserState;
import com.ibatis.sqlmap.engine.mapping.parameter.ParameterMapping;
import com.ibatis.sqlmap.engine.mapping.statement.MappedStatement;
import com.ibatis.sqlmap.engine.mapping.statement.StatementType;
import com.ibatis.sqlmap.engine.scope.SessionScope;
import com.ibatis.sqlmap.engine.scope.StatementScope;

/**
 * iBatis の sqlMap ファイルから、検索結果の行を表すバリューオブジェクトを自動生成します。
 * 
 * SELECT のみを処理対象とします。
 * 
 * @author IGA Tosiki
 */
public class BlancoIBatisSqlMap2RowProcessImpl implements
        BlancoIBatisSqlMap2RowProcess {
    protected BlancoIBatisMessage fMsg = new BlancoIBatisMessage();

    protected BlancoIBatisSqlMap2RowProcessInput fInput = null;

    /**
     * クラスをインスタンス化して処理を実行する際のエントリポイントです。
     * 
     * @param input
     *            処理の入力パラメータ。
     * @return 処理の実行結果。
     * @throws IOException
     *             入出力例外が発生した場合。
     * @throws IllegalArgumentException
     *             入力値に不正が見つかった場合。
     */
    public int execute(final BlancoIBatisSqlMap2RowProcessInput input)
            throws IOException, IllegalArgumentException {
        fInput = input;

        if (new File(fInput.getSourcedir()).exists() == false) {
            throw new IllegalArgumentException(fMsg.getMbibri01(fInput
                    .getSourcedir()));
        }
        if (new File(fInput.getSourcedir()).isDirectory() == false) {
            throw new IllegalArgumentException(fMsg.getMbibri02(fInput
                    .getSourcedir()));
        }

        Connection conn = null;
        try {
            conn = BlancoDbMetaDataUtil.connect(fInput.getJdbcdriver(), fInput
                    .getJdbcurl(), fInput.getJdbcuser(), fInput
                    .getJdbcpassword());
        } catch (IllegalArgumentException ex) {
            System.out.println(fMsg.getMbibrp01(ex.toString()));
            return BlancoIBatisSqlMap2RowBatchProcess.END_ERROR;
        }

        try {
            processSqlMapDir(conn, new File(fInput.getSourcedir()));
        } finally {
            try {
                conn.rollback();
                conn.close();
            } catch (SQLException e) {
                // これは基本的にはありえないはず。
                e.printStackTrace();
            }
        }

        return 0;
    }

    /**
     * sqlMap が格納されているディレクトリ内のすべての xml ファイルを処理します。
     * 
     * @param conn
     *            データベース接続。
     * @param sourceDir
     *            入力ディレクトリ。
     * @throws IOException
     */
    public void processSqlMapDir(final Connection conn, final File sourceDir)
            throws IOException {
        final File[] files = sourceDir.listFiles();
        if (files == null) {
            return;
        }
        for (int index = 0; index < files.length; index++) {
            if (files[index].isFile() == false) {
                continue;
            }
            if (files[index].getName().endsWith(".xml") == false) {
                continue;
            }

            try {
                processSqlMap(conn, files[index]);
            } catch (NodeletException e) {
                System.out.println(fMsg.getMbibrp02(files[index].getName(), e
                        .toString()));
                if (fInput.getVerbose()) {
                    e.printStackTrace();
                }
                continue;
            }
        }
    }

    /**
     * sqlMap ファイルから 行をあらわすバリューオブジェクトを生成します。
     * 
     * @param conn
     *            データベース接続。
     * @param fileSqlMap
     *            sqlMap のファイル。
     * @throws IOException
     *             入出力例外が発生した場合。
     * @throws NodeletException
     * @throws SQLException
     *             SQL例外が発生した場合。
     */
    @SuppressWarnings("unchecked")
    public void processSqlMap(final Connection conn, final File fileSqlMap)
            throws IOException, NodeletException {
        final XmlParserState parserState = new XmlParserState();

        final InputStream inStream = new BufferedInputStream(
                new FileInputStream(fileSqlMap));
        try {
            final SqlMapParser parser = new SqlMapParser(parserState);
            parser.parse(inStream);
        } finally {
            inStream.close();
        }

        for (Iterator<String> iteSqlMapId = parserState.getConfig()
                .getDelegate().getMappedStatementNames(); iteSqlMapId.hasNext();) {
            final MappedStatement mStmt = parserState.getConfig().getDelegate()
                    .getMappedStatement(iteSqlMapId.next());

            if (mStmt.getStatementType() != StatementType.SELECT) {
                // SELECT以外は処理しません。
                continue;
            }

            try {
                processSqlMapEntry(conn, mStmt);
            } catch (SQLException e) {
                System.out.println(fMsg.getMbibrp03(fileSqlMap.getName(), mStmt
                        .getId(), e.toString()));
                if (fInput.getVerbose()) {
                    e.printStackTrace();
                }
                continue;
            } catch (ProbeException e) {
                System.out.println(fMsg.getMbibrp04(fileSqlMap.getName(), mStmt
                        .getId(), e.toString()));
                if (fInput.getVerbose()) {
                    e.printStackTrace();
                }
                continue;
            }
        }
    }

    protected void processSqlMapEntry(final Connection conn,
            final MappedStatement mStmt) throws SQLException, IOException {
        if (false) {
            // TODO このメソッドから動的SQLのパラメータを取得できれば良いのだが、そこはうまくいかない。
            // TODO 現在の iBatis 実装では、プログラム実行時に呼び出し元で与えられたパラメータの利用が前提となってしまっている模様。
            final ParameterMapping[] mappings = mStmt.getParameterMap()
                    .getParameterMappings();
            if (mappings != null) {
                for (int index = 0; index < mappings.length; index++) {
                    System.out.println("  trace: param: "
                            + mappings[index].getPropertyName());
                }
            }
        }

        // SQL文字列を取得。
        final String sql = mStmt.getSql().getSql(
                new StatementScope(new SessionScope()), null);

        List<BlancoDbMetaDataColumnStructure> columnList = null;

        if (fInput.getIsbindparameter() == false) {
            // パラメータをバインドせずに生成。
            columnList = BlancoDbMetaDataSql.getResultSetMetaData(conn, sql);
        } else {
            // パラメータを使った解析を行うかどうかについては微妙。
            final List<BlancoDbMetaDataColumnStructure> paramList = new ArrayList<BlancoDbMetaDataColumnStructure>();

            int replaceCount = 0;
            for (int index = 0; index < sql.length(); index++) {
                // TODO SQL文中の " エスケープや コメントの考慮が抜けています。
                if (sql.charAt(index) == '?') {
                    replaceCount++;
                    final BlancoDbMetaDataColumnStructure param = new BlancoDbMetaDataColumnStructure();
                    paramList.add(param);
                    // とりあえず文字ということにしてセット。
                    param.setDataType(java.sql.Types.CHAR);
                }
            }

            columnList = BlancoDbMetaDataSql.getResultSetMetaData(conn, sql,
                    paramList);
        }

        columnList2RowValueObject(mStmt, columnList);
    }

    /**
     * 列リストから 行を表すバリューオブジェクトを生成します。
     * 
     * @param mStmt
     * @param columnList
     * @throws IOException
     */
    protected void columnList2RowValueObject(final MappedStatement mStmt,
            final List<BlancoDbMetaDataColumnStructure> columnList)
            throws IOException {
        final BlancoValueObjectClassStructure rowValueObject = new BlancoValueObjectClassStructure();
        // blancoDbのサフィックス・ルールに合わせて、ファイル名には Row を付与します。
        rowValueObject.setName(BlancoNameAdjuster.toClassName(mStmt.getId())
                + "Row");
        // パッケージは外部から与えてください。
        rowValueObject.setPackage(fInput.getPackage());
        rowValueObject.setDescription("sqlMap id [" + mStmt.getId()
                + "] の検索結果の行オブジェクト。\n <select id=\"" + mStmt.getId()
                + "\" resultClass=\"" + fInput.getPackage() + "."
                + BlancoNameAdjuster.toClassName(mStmt.getId()) + "Row"
                + "\" ...");

        for (BlancoDbMetaDataColumnStructure column : columnList) {
            final BlancoValueObjectFieldStructure field = new BlancoValueObjectFieldStructure();
            rowValueObject.getFieldList().add(field);

            field.setName(column.getName());
            field.setType(BlancoDbMappingUtilJava.getFullClassName(column));
            StringBuffer buf = new StringBuffer();
            buf.append("DB上は" + column.getDataTypeDisplayName() + "。");
            if (column.getNullable() == ResultSetMetaData.columnNoNulls) {
                buf.append("非null。");
            } else if (column.getNullable() == ResultSetMetaData.columnNullable) {
                buf.append("null許容。");
            }
            buf.append("サイズ:" + column.getColumnSize());
            field.setDescription(buf.toString());
        }

        final BlancoValueObjectXml2JavaClass xml2source = new BlancoValueObjectXml2JavaClass();
        xml2source.setEncoding(fInput.getEncoding());
        xml2source.structure2Source(rowValueObject, new File(fInput
                .getTargetdir()));
    }
}
